%define debug_package %{nil}
%define base_install_dir %{_javadir}{%name}

Name:           elasticsearch
Version:        0.19.9
Release:        5%{?dist}
Summary:        A distributed, highly available, RESTful search engine

Group:          System Environment/Daemons
License:        ASL 2.0
URL:            http://www.elasticsearch.com
Source0:        https://github.com/downloads/%{name}/%{name}/%{name}-%{version}.tar.gz
Source1:        init.d-elasticsearch
Source2:        logrotate.d-elasticsearch
Source3:        config-logging.yml
Source4:        sysconfig-elasticsearch
Source5:        tmpfiles.d-elasticsearch
Patch0:         elasticsearch-classpath.patch
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:       jpackage-utils
Requires:       java
Requires:       sigar-java >= 1.6.4
Requires:       jna >= 3.2.4
Requires:       snappy-java >= 1.0.4
Requires:       log4j >= 1.2.14
Requires:       lucene3 >= 3.0.3
Requires:       lucene3-contrib >= 3.0.3

Requires(post): chkconfig initscripts
Requires(pre):  chkconfig initscripts
Requires(pre):  shadow-utils

%description
A distributed, highly available, RESTful search engine

%prep
%setup -q -n %{name}-%{version}
%patch0 -p0


%build
true

%install
rm -rf $RPM_BUILD_ROOT

%{__mkdir} -p %{buildroot}%{_javadir}/%{name}/bin
%{__install} -p -m 755 bin/elasticsearch %{buildroot}%{_javadir}/%{name}/bin
%{__install} -p -m 644 bin/elasticsearch.in.sh %{buildroot}%{_javadir}/%{name}/bin
%{__install} -p -m 755 bin/plugin %{buildroot}%{_javadir}/%{name}/bin

#libs
%{__mkdir} -p %{buildroot}%{_javadir}/%{name}/lib
%{__install} -p -m 644 lib/%{name}-%{version}.jar %{buildroot}%{_javadir}/%{name}/lib

# config
%{__mkdir} -p %{buildroot}%{_sysconfdir}/elasticsearch
%{__install} -m 644 config/elasticsearch.yml %{buildroot}%{_sysconfdir}/%{name}
%{__install} -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/%{name}/logging.yml

# data
%{__mkdir} -p %{buildroot}%{_localstatedir}/lib/%{name}

# logs
%{__mkdir} -p %{buildroot}%{_localstatedir}/log/%{name}
%{__install} -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/elasticsearch

# plugins
%{__mkdir} -p %{buildroot}%{_javadir}/%{name}/plugins

# sysconfig and init
%{__mkdir} -p %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__mkdir} -p %{buildroot}%{_sysconfdir}/sysconfig
%{__install} -m 755 %{SOURCE1} %{buildroot}%{_sysconfdir}/rc.d/init.d/elasticsearch
%{__install} -m 755 %{SOURCE4} %{buildroot}%{_sysconfdir}/sysconfig/elasticsearch

%{__mkdir} -p %{buildroot}%{_localstatedir}/run/elasticsearch
%{__mkdir} -p %{buildroot}%{_localstatedir}/lock/subsys/elasticsearch

#tmpfiles on Fedora
%if 0%{?fedora}
install -D -m 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/tmpfiles.d/elasticsearch.conf
%endif

%pre
# create elasticsearch group
if ! getent group elasticsearch >/dev/null; then
        groupadd -r elasticsearch
fi

# create elasticsearch user
if ! getent passwd elasticsearch >/dev/null; then
        useradd -r -g elasticsearch -d %{_javadir}/%{name} \
            -s /sbin/nologin -c "You know, for search" elasticsearch
fi

%post
/sbin/chkconfig --add elasticsearch

%preun
if [ $1 -eq 0 ]; then
  /sbin/service elasticsearch stop >/dev/null 2>&1
  /sbin/chkconfig --del elasticsearch
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{_sysconfdir}/rc.d/init.d/elasticsearch
%config(noreplace) %{_sysconfdir}/sysconfig/elasticsearch
%{_sysconfdir}/logrotate.d/elasticsearch
%if 0%{?fedora}
%{_sysconfdir}/tmpfiles.d/elasticsearch.conf
%endif
%dir %{_javadir}/elasticsearch
%{_javadir}/elasticsearch/bin/*
%{_javadir}/elasticsearch/lib/%{name}-%{version}.jar
%dir %{_javadir}/elasticsearch/plugins
%config(noreplace) %{_sysconfdir}/elasticsearch
%doc LICENSE.txt  NOTICE.txt  README.textile
%defattr(-,elasticsearch,elasticsearch,-)
%dir %{_localstatedir}/lib/elasticsearch
%{_localstatedir}/run/elasticsearch
%dir %{_localstatedir}/log/elasticsearch


%changelog
* Mon Dec 10 2012 Martin Bačovský <mbacovsk@redhat.com> 0.19.9-5
- Rebuild for SAM 1.2

* Fri Nov 16 2012 Ivan Necas <inecas@redhat.com> 0.19.9-4
- Add tmpfiles.d configuration to prepare the /var/run/elasticsearch dir
  (inecas@redhat.com)

* Tue Nov 13 2012 Miroslav Suchý <msuchy@redhat.com> 0.19.9-3
- 868286 - do not be verbose during startup (msuchy@redhat.com)

* Thu Nov 08 2012 Martin Bačovský <mbacovsk@redhat.com> 0.19.9-1
- Updated to 0.19.9 

* Mon Jul 02 2012 Miroslav Suchý <msuchy@redhat.com> 0.18.4-13
- add tar.gz and patches (msuchy@redhat.com)

* Mon Jul 02 2012 Miroslav Suchý <msuchy@redhat.com> 0.18.4-12
- do not mix space and tabs, and provide correct url for SOURCE0
- %%defattr is not needed since rhel5
- build root is not needed

* Mon Jul 02 2012 Miroslav Suchý <msuchy@redhat.com> 0.18.4-11
- new package built with tito

* Mon Apr 9 2012 Bryan Kearney <bkearney@redht.com> - 0.18.4-11
- Downgrade the version of jna to 3.2.4 from 3.2.7

* Thu Apr 5 2012 Bryan Kearney <bkearney@redht.com> - 0.18.4-10
- Downgrade the version of log4j to 1.2.14 from 1.2.16.

* Mon Mar 26 2012 Jordan OMara <jomara@redhat.com> - 0.18.4-9
- Setting buildarch to noarch 

* Mon Mar 19 2012 Justin Sherrill <jsherril@redhat.com> - 0.18.4-8
- Setting static UID & GID for elasticsearch user

* Tue Jan 3 2012 Shannon Hughes <shughes@redhat.com> - 0.18.4-7
- remove sigar deps

* Wed Dec 14 2011 Shannon Hughes <shughes@redhat.com> - 0.18.4-6
- Initial package
